use crate::usimp::subscription;
use crate::usimp::*;

use serde::{Deserialize, Serialize};
use serde_json::{from_value, to_value, Value};

#[derive(Serialize, Deserialize, Clone)]
struct Input {
    room_id: String,
    events: Vec<Event>,
}

#[derive(Serialize, Deserialize, Clone)]
struct Output {}

pub async fn handle(input: &InputEnvelope, session: Option<Session>) -> Result<Value, Error> {
    Ok(to_value(
        new_event(from_value(input.data.clone())?, session).await?,
    )?)
}

async fn new_event(input: Input, session: Option<Session>) -> Result<Output, Error> {
    let _account = get_account(&session)?;
    // TODO check permissions
    for event in input.events {
        subscription::push(input.room_id.as_str(), event).await?;
    }
    Ok(Output {})
}
